
#include "stdafx.h"
#include "vJoy\inc\public.h"
#include "vJoy\inc\vjoyinterface.h"
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#pragma comment( lib, "VJOYINTERFACE" )

//////////////////////////////////////////////////////////////////////////////////
// Helper Macros - use as you please

#define GETFLOAT(p) *((float*)&p)
#define GETBOOL(p) *((bool*)&p)
#define GETINT(p) p
#define GETSTRING(p) *((char**)&p)
#define GETFLOATARRAY(p) p ? ((float*)p+1) : 0
#define GETINTARRAY(p) p ? ((int*)p+1) : 0
#define GETSTRINGARRAY(p) p ? ((char**)p+1) : 0
#define GETARRAYSIZE(p) p ? *((int*)p) : 0
#define GETFRAME(p) p ? ((float*)p+1) : 0
#define GETFRAMESIZE(p) p ? *((int*)p) : 0
#define GETBITMAPWIDTH(p) p ? *((int*)p) : 0
#define GETBITMAPHEIGHT(p) p ? *((int*)p+1) : 0
#define GETBITMAPCHANNELS(p) p ? *((int*)p+2) : 0
#define GETBITMAPDATA(p) p ? ((BYTE*)p+12) : 0
#define GETBITMAPBYTES(p) p ? *((int*)p) * *((int*)p+1) * *((int*)p+2) : 0
#define NEWINTARRAY(p,n) if(n>0) { *((int**)&p)=new int[n+1]; ((int*)p)[0]=n; }
#define NEWFLOATARRAY(p,n) if(n>0) { *((float**)&p)=new float[n+1]; ((int*)p)[0]=n; }
#define NEWSTRINGARRAY(p,n) if(n>0) { *((char***)&p)=new char*[n+1]; ((int*)p)[0]=n; }
#define DELETESTRING(p) if(p) { delete *((char**)&p); p=0; }
#define DELETEINTARRAY(p) if(p) { delete *((int**)&p); p=0; }
#define DELETEFLOATARRAY(p) if(p) { delete *((float**)&p); p=0; }
#define DELETESTRINGARRAY(p) if(p) { for( int j=0; j<*((int*)p); j++ ) { if( ((char**)p+1)[j] ) delete ((char**)p+1)[j]; } delete *((char***)&p); p=0; }

VJOYINTERFACE_API enum VjdStat	__cdecl	GetVJDStatus(UINT rID);			// Get the status of the specified vJoy Device.
VJOYINTERFACE_API SHORT __cdecl GetvJoyVersion(void);
VJOYINTERFACE_API BOOL	__cdecl vJoyEnabled(void);
VJOYINTERFACE_API PVOID	__cdecl	GetvJoyProductString(void);
VJOYINTERFACE_API PVOID	__cdecl	GetvJoyManufacturerString(void);
VJOYINTERFACE_API PVOID	__cdecl	GetvJoySerialNumberString(void);

//////////////////////////////////////////////////////////////////////////////////

extern "C" __declspec(dllexport) void myfunction( int nParams, int* pIn, int* pOut )
{
	GETSTRING(pOut[1]) = "DLL Started";

	UINT iInterface = GETINT(pOut[0]);
	CHAR HLPer[128];


	// Check the driver attributes
	if (!vJoyEnabled())
	{
		GETSTRING(pOut[1]) = "Failed Getting vJoy attributes.";
		return;
	}
	else
	{
		GETSTRING(pOut[1]) = "yJoy was found.";
	};

	// Get the state of the requested device
	VjdStat status = GetVJDStatus(iInterface);

	switch (status)
	{
	case VJD_STAT_OWN:
		_snprintf_s(HLPer,(size_t)255,"vJoy Device %d is already owned by this feeder", iInterface);
		break;
	case VJD_STAT_FREE:
		_snprintf_s(HLPer,(size_t)255,"vJoy Device %d is free\n", iInterface);
		break;
	case VJD_STAT_BUSY:
		_snprintf_s(HLPer,(size_t)255,"vJoy Device %d is already owned by another feeder\nCannot continue", iInterface);
		GETSTRING(pOut[1]) = HLPer;
		return;
	case VJD_STAT_MISS:
		_snprintf_s(HLPer,(size_t)255,"vJoy Device %d is not installed or disabled\nCannot continue", iInterface);
		GETSTRING(pOut[1]) = HLPer;
		return;
	default:
		_snprintf_s(HLPer,(size_t)255,"vJoy Device %d general error\nCannot continue", iInterface);
		GETSTRING(pOut[1]) = HLPer;
		return;
	};

	// Acquire the target
	if ((status == VJD_STAT_OWN) || ((status == VJD_STAT_FREE) && (!AcquireVJD(iInterface))))
	{
		_snprintf_s(HLPer,(size_t)255,"Failed to acquire vJoy device number %d.\n", iInterface);
		GETSTRING(pOut[1]) = HLPer;
		return;
	}
	else
	{
		_snprintf_s(HLPer,(size_t)255,"Acquired: vJoy device number %d.\n", iInterface);
	}

	INT iAxis = GETINT(pOut[2]);
	INT aAxis;

	switch(iAxis)
	{
	case 0:
		aAxis=HID_USAGE_X;
		break;
	case 1:
		aAxis=HID_USAGE_Y;
		break;
	case 2:
		aAxis=HID_USAGE_Z;
		break;
	case 3:
		aAxis=HID_USAGE_RX;
		break;
	case 4:
		aAxis=HID_USAGE_RY;
		break;
	case 5:
		aAxis=HID_USAGE_RZ;
		break;
	case 6:
		aAxis=0;
		break;
	default:
		GETSTRING(pOut[1]) = "No Axis Selected";
		return;
	};

	INT iValue = GETINT(pOut[3]);
	BOOL res = FALSE;
	
	res = SetAxis(iValue, iInterface, aAxis);
	return;
}